import { useContext, useState, useLayoutEffect, useRef } from 'react';
import { LocalesContext } from "./context.js";
import format from "./messageFormat.js";
export const useLocales = (path, object) => {
  const firstDraw = useRef(true);
  const {
    getMessages,
    lang
  } = useContext(LocalesContext);
  const [messages, setMessages] = useState(getMessages(path));
  useLayoutEffect(() => {
    const rawMessage = getMessages(path);
    if (firstDraw.current && !object) return;
    firstDraw.current = false;

    if (!object) {
      setMessages(rawMessage);
      return;
    }

    setMessages(Object.entries(rawMessage).reduce((acc, [key, value]) => ({ ...acc,
      [key]: format(value, object, lang)
    }), {}));
  }, [object]);
  return messages;
};